package cn.com.qmth.examcloud.exchange.inner.api.client;

import java.io.File;
import java.util.Map;

import org.apache.commons.fileupload.disk.DiskFileItem;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.web.client.RestTemplate;
import org.springframework.web.multipart.commons.CommonsMultipartFile;

import com.google.common.collect.Maps;

import cn.com.qmth.examcloud.commons.web.redis.RedisClient;
import cn.com.qmth.examcloud.exchange.inner.api.UpyunCloudService;
import cn.com.qmth.examcloud.exchange.inner.api.request.PutFileReq;
import cn.com.qmth.examcloud.exchange.inner.api.response.PutFileResp;

/**
 * 类注释
 *
 * @author WANGWEI
 * @date 2018年11月27日
 * @Copyright (c) 2018-? http://qmth.com.cn All Rights Reserved.
 */
@Service
public class UpyunCloudServiceClient extends ExchangeCloudClientSupport
		implements
			UpyunCloudService {

	private static final long serialVersionUID = -7928075025404055161L;

	@Autowired
	RestTemplate restTemplate;

	@Autowired
	private RedisClient redisClient;

	@Override
	protected RedisClient getRedisClient() {
		return redisClient;
	}

	@Override
	protected RestTemplate getRestTemplate() {
		return restTemplate;
	}

	@Override
	public PutFileResp putFile(PutFileReq req) {
		Map<String, String> params = Maps.newHashMap();
		params.put("fileName", req.getFileName());
		params.put("siteId", req.getSiteId());
		params.put("rootOrgId", String.valueOf(req.getRootOrgId()));
		params.put("userId", String.valueOf(req.getUserId()));

		CommonsMultipartFile file = req.getFile();
		DiskFileItem item = (DiskFileItem) file.getFileItem();
		File storeLocation = item.getStoreLocation();
		return postForm("upyun/putFile", params, storeLocation, PutFileResp.class);
	}

}
